C PROGRAM SPINTERP
C     **************************************************************
C                        Istanbul Technical University                   
C                     Faculty of Mines, Geophysics Department,          
C                        80626 Ayazaa, stanbul, Turkey.                
C            SPINTERP Program =Visual interpretation of SP anomaly   
C                          author : I.Caglar                             
C                Email:caglari@itu.edu.tr    Fax:90(212)2856201        
C     **************************************************************
$large
      include 'fgraph.fi'
      include 'text2.ekm'
      include 'fgraph.fd'
      integer*2 oku
      character*17 sp(16)
      character*32 ss
      dimension spx(3)
      common /sp/sp
      call kontrol()
      call kontrol1()
      call spler()
      spx(1)=4
      spx(2)=3
      spx(3)=4
      nust=1
      nyan=1
C     *************************************************************
C                              Main program                              
C     *************************************************************
      m=setvideomode(18)
      ss='EXIT FROM SPINTERP?(YES-y NO-n)'
      if(m.eq.0)stop 'Screen chart must be VGA!!!'
      call giris(ncik)
      if(ncik.eq.5) goto 8
      call ekran()
      call menu1gir(1)
      call menu1gir(0)
    4 call menu1(nust,9)
      call menu2(nyan+nust*4,9)
      oku=readkey()
      call menu2(nyan+nust*4,7)
      call menu1(nust,7)
	 if(oku.eq.331) nust=nust-1
	 if(oku.eq.333) nust=nust+1
	 if(oku.eq.328) nyan=nyan-1
	 if(oku.eq.336) nyan=nyan+1
	    if(nyan.lt.1) nyan=spx(nust)
	    if(nyan.gt.spx(nust)) nyan=1
	    if(nust.lt.1) nust=3
	    if(nust.gt.3) nust=1
	 if(oku.eq.331.or.oku.eq.333)then
	    nyan=1
	    call menu1gir(nust)
	 endif
	 if(oku.eq.27) then
	    call cikis(gm,ss,280)
	    if(gm.eq.27) goto 8
	 endif
	 if(nust.eq.1.and.oku.eq.13) goto (11,21,22,23)nyan
	 if(nust.eq.2.and.oku.eq.13) goto (31,41,42)nyan
	 if(nust.eq.3.and.oku.eq.13) goto (51,61,71,81)nyan
      goto 4
C     *************************************************************
C                          SUBROUTINE calling                              
C     *************************************************************
   22 call modelkayiti()
      call menu1gir(1)
      nyan=1
      goto 3
   23 call modelgirisi()
      call menu1gir(1)
      nyan=1
      goto 3
   21 call degerdon()
      call menu1gir(1)
      nyan=1
      goto 3
C***********************************************************
   31 call grafprint()
      call menu1gir(2)
      nyan=1
      goto 3
C***********************************************************
   41 call yaziprint(190)
      call menu1gir(2)
      nyan=1
      goto 3
c***********************************************************
   42 call goster()
      call menu1gir(2)
      nyan=1
      goto 3
   51 call dogalucla()
      call menu1gir(3)
      nyan=1
      goto 3
c***********************************************************
   61 call silimodel()
      call menu1gir(3)
      nyan=1
      goto 3
c***********************************************************
   71 call dilimmodel()
      call menu1gir(3)
      nyan=1
      goto 3
c***********************************************************
   81 call kuremodel()
      call menu1gir(3)
      nyan=1
      goto 3
c***********************************************************
   11 call dosyagir()
      call menu1gir(1)
      nyan=1
c***********************************************************
    3 call spler()
      spx(3)=4
      call menu1gir(0)
      goto 4
c***********************************************************
    8 call kapan()
      m=setvideomode(-1)
      end
C     *************************************************************
C     *                     PROGRAM flows                         *      
C     *************************************************************
      block data
      common /doscu/ kayitno
      common /sayi/ nart
      common /say/ dsayi
      data dsayi/1/
      data nart/1/
      data kayitno/1/
      end

      subroutine dosyagir()
      include 'fgraph.fd'
      dimension x(1500),y(1500)
      dimension yv(1500),xx(1500)
      common /veri/ tt
      common /olsan / yv,xx
      common /doscu/ kayitno
      common /kayiticin/ x,y
      common /say/ dsayi
      common /sayi/ nart
      common /sert /xmax,xmin,ymax,ymin,n
      character*20 tt
      call dossor()
      call gets(33,70,tt,15,doscik)
      if(doscik.eq.11) return
      if(tt.eq.' ') return
      open(12,file=tt,status='old',err=31)
      yv=0.0
      x=0.0
      y=0.0
      n=0
    3 read(12,*,end=5) x(n+1),y(n+1)
      n=n+1
      goto 3
    5 continue
      close(12)
      nart=1
      dsayi=1
      call vericiz()
      call okcu()
      return
   31 call hata('Missing file')
   32 return
      end

C     *************************************************************
C     *                    MODEL file input                       *      
C     *************************************************************
      subroutine modelgirisi()
      include 'fgraph.fd'
      dimension yv(1500),xx(1500)
      dimension y(1500),x(1500)
      dimension gel(35),tekm(35),tekh(35),tekal(35)
      integer*1 selma6(520)
      character*8 tez(35)
      character*20 tt
      common /gf6/ selma6
      common /veri/ tt
      common /olsan / yv,xx
      common /kayiticin/ x,y
      common /doscu/ kayitno
      common /degerler/ gel,tez,tekm,tekh,tekal
      common /sert /xmax,xmin,ymax,ymin,n
      common /say/ dsayi
      common /sayi/ nart
      call dossor()
      call gets(33,70,tt,15,doscik)
      if(doscik.eq.11) return
      if(tt.eq.' ') return
      yv=0.0
      open(12,file=tt,status='old',err=68)
      read(12,*) dsayi
      do i=1,dsayi
      read(12,13) gel(i),tez(i),tekm(i),tekh(i),tekal(i)
      enddo
   13 format(f9.2,1x,a8,1x,f9.2,1x,f9.2,1x,f9.2)
      read(12,*) n
      do i=1,n
      read(12,*) x(i),y(i)
      enddo
      read(12,*) nart
      do i=1,nart
      read(12,*) xx(i),yv(i)
      enddo
      close(12)
      dsayi=dsayi+1
      call kose(172,29,635,450,0,0)
      call gulme()
      call okcu()
      return
   68 call tleky(210,100,600,169,7)
      call putimage(218,110,selma6,3)
      call text(252,112,'The format of the file is not true for ')
      call text(252,127,'SPINTERP ')
      call text(252,142,' ')
      oku=readkey()
      call kose(172,29,635,450,0,0)
      return
      end


C     *************************************************************
C     *                    MODEL saving                           *      
C     *************************************************************
      subroutine modelkayiti()
      include 'fgraph.fd'
      character*8 tez(35)
      character*20 tkayit
      integer*1 selma6(520)
      dimension gel(35),tekm(35),tekh(35),tekal(35)
      dimension x(1500),y(1500)
      dimension yv(1500),xx(1500)
      common /olsan / yv,xx
      common /kayiticin/ x,y
      common /sert /xmax,xmin,ymax,ymin,n
      common /degerler/ gel,tez,tekm,tekh,tekal
      common /say/ dsayi
      common /doscu/ kayitno
      common /gf6/ selma6
      common /sayi/ nart
      if(kayitno.eq.1) then
	  call kose(190,29,635,434,0,0)
	  call tleky(210,100,600,169,7)
	  call putimage(218,110,selma6,3)
          call text(252,112,'No interpretation is made.          ')
	  call text(252,127,'Use FILE option to enter            ')
	  call text(252,142,'input data file                 ')
	  oku=readkey()
	  call kose(172,29,635,450,0,0)
	  return
      endif
      if(nart.eq.1) then
	   call tleky(210,100,600,169,7)
	   call putimage(218,110,selma6,3)
	   call text(252,112,'No interpretation is made.           ')
           call text(252,127,'Select suitable model using S P or C  ')
	   oku=readkey()
	   call kose(172,29,635,450,0,0)
	   return
      endif
      call dossor()
      call gets(33,70,tkayit,15,doscik)
      if(doscik.eq.11) return
      if(tkayit.eq.' ') return
      open(15,file=tkayit,status='unknown')
      write(15,4) dsayi-1
      do i=1,dsayi-1
	write(15,4) gel(i),tez(i),tekm(i),tekh(i),tekal(i)
      enddo
    4 format(f9.2,1x,a8,1x,f9.2,1x,f9.2,1x,f9.2)
      write(15,*) n
      do i=1,n
      write(15,*) x(i),y(i)
      enddo
      write(15,*) nart
      do i=1,nart
      write(15,*) xx(i),yv(i)
      enddo
      close(15)
      return
      end




C     *************************************************************
C     *                    Data processing                        *      
C     *************************************************************
      subroutine degerdon()
      include'fgraph.fd'
      integer*1 selma6(520)
      common /gf6/ selma6
      common /doscu/ kayitno
      if(kayitno.eq.1) then
	  call kose(190,29,635,434,0,0)
	  call tleky(210,100,600,169,7)
	  call putimage(218,110,selma6,3)
	  call text(252,112,'No interpretation is made.           ')
	  call text(252,127,'Use FILE option ')
	  call text(252,142,'to enter INPUT file  ')
	  oku=readkey()
	  call kose(190,29,635,434,0,0)
	  return
      endif
      call gulme()
      call okcu()
      return
      end

C     *************************************************************
C     *                 GRAPHIC output                            *      
C     *************************************************************

      subroutine grafprint()
      include'fgraph.fd'
      integer*1 selma6(520)
      character*40 tprint
      common /doscu/ kayitno
      common /olsan / yv,xx
      common /sayi/ nart
      common /gf6/ selma6
      dimension yv(1500),xx(1500)
      m=registerfonts('sptimes.fnt')
      if(kayitno.eq.1) then
	  call kose(190,29,635,434,0,0)
	  call tleky(210,100,600,169,7)
	  call putimage(218,110,selma6,3)
	  call text(252,112,'No INPUT file is given')
	  call text(252,127,'Use  FILE option to enter')
	  call text(252,142,'Input file for interpretation...')
	  oku=readkey()
	  call kose(172,29,635,450,0,0)
	  return
      endif
      call sil()
      call printuyari(tprint,doscik)
      if(doscik.eq.11) then
	   call kose(173,29,635,450,0,0)
	   return
      endif
      call kose(173,4,635,21,0,0) ! st tepe
      call text(267,6,tprint)
      call kose(173,29,635,450,0,0)
      if(nart.eq.1) then
	   call kose(173,29,635,450,0,0)
	   goto 21
      endif
      call gulme()
   21 call printer(45,195,4,635,17,3)
      call printer(28,172,29,635,442,3)
      call yaziprint(123)
      call kose(173,4,635,21,7,7) ! st tepe
      call kose(173,29,635,450,0,0)
      call text(270,6,'Visual interpretation of SP anomalies')
      return
      end

C***************************************************************
      subroutine yaziprint(nelli)
      include 'fgraph.fd'
      character*8 tez(35)
      character*40 tprint
      character*20 tt
      integer*1 selma6(520)
      common /degerler/ gel,tez,tekm,tekh,tekal
      common /say/ dsayi
      common /sayi/ nart
      common /veri/ tt
      common /doscu/ kayitno
      common /gf6/ selma6
      common /sert /xmax,xmin,ymax,ymin,n
      dimension gel(35),tekm(35),tekh(35),tekal(35)
      if(kayitno.eq.1) then
	  call kose(190,29,635,434,0,0)
	  call tleky(210,100,600,169,7)
	  call putimage(218,110,selma6,3)
	  call text(252,112,'No interpretation is made.')
	  call text(252,127,'Use FILE option to enter')
	  call text(252,142,'Input data file')
	  oku=readkey()
	  call kose(172,29,635,450,0,0)
	  return
      endif
      if(nelli.eq.123) goto 16
      if(nart.eq.1) then
	    call tleky(210,100,600,169,7)
	   call putimage(218,110,selma6,3)
	   call text(252,112,'No interpretation is made.')
           call text(252,127,'Select suitable model using S P or C')
	   call text(252,142,'to start interpretation')
	   oku=readkey()
	   call kose(172,29,635,450,0,0)
	   return
      endif
      call printuyari(tprint,doscik)
      if(doscik.eq.11) then
	   call kose(172,29,635,450,0,0)
	   return
      endif
      open(10,file='prn')
      do i=1,3
	 write(10,*) ' '
      enddo
      write(10,12) tprint
   12 format(20x,a45)
      do i=1,4
	 write(10,*) ' '
      enddo
      write(10,13) tt
      write(10,*) ' '
      write(10,*) ' '
      write(10,14) xmax,xmin
      write(10,15) ymax,ymin
      write(10,*) ' '
      write(10,*) ' '
      close(10)
   13 format(13x,'INPUT FILE  :',a15)
   14 format(13x,'Xmax = ',f9.2,7x,'Xmin=',f9.2)
   15 format(13x,'Vmax = ',f9.2,7x,'Vmin=',f9.2)
   16 open(10,file='prn')
      write(10,2)
      write(10,3)
    2 format(13x,'X(meter)',7x,'BODY',8x,'M(mV)',6x,'h(meter)',7x,'P.angle
     1')
    3 format(12x,'----------',5x,'---------',4x,'-------',5x,'--------',
     16x,'-------')
      do i=1,dsayi-1
	write(10,4) gel(i),tez(i),tekm(i),tekh(i),tekal(i)
      enddo
    4 format(13x,f6.0,9x,a8,5x,f6.0,5x,f6.0,8x,f6.0)
      close(10)
      return
      end
C**********************************************************
      subroutine gulme()
      include'fgraph.fd'
      dimension yv(1500),xx(1500)
      common /olsan / yv,xx
      common /sert /xmax,xmin,ymax,ymin,n
      common /sayi/ nart
      common /doscu/ kayitno
      record/xycoord/s
      if(kayitno.eq.1) return
      call kose(173,29,635,450,0,0)
      call vericiz()
c****************************************
      call setviewport(172,29,635,411)
c****************************************
      m=setcolor(15)
      call map(xmax,xmin,xx(1),30.,464.,xxi)
      call map(ymax,ymin,yv(1),380.,1.,yvi)
      xx1=xxi
      yv1=yvi
      call moveto(xx1,yv1,s)
      do i=2,nart
	   call map(xmax,xmin,xx(i),30.,464.,xxi)
	   call map(ymax,ymin,yv(i),380.,1.,yvi)
	   xx1=xxi
	   yv1=yvi
	   m=lineto(xx1,yv1)
       enddo
      call setviewport(0,0,639,479)
      return
      end
		
C     *************************************************************
C     *                  Sphere anomaly                           *      
C     *************************************************************
      subroutine anomalikure(gelok)
      include 'fgraph.fd'
      character*8 tez(35)
      common /olsan / yv,xx
      common /anomali/ verilk,verson
      common /sert /xmax,xmin,ymax,ymin,n
      common /sayi/ nart
      common /say/ dsayi
      common /gf7/ selma7
      common /degerler/ gel,tez,tekm,tekh,tekal
      integer*1 selma7(520)
      dimension yv(1500),xx(1500)
      dimension gel(35),tekm(35),tekh(35),tekal(35)
      record/xycoord/s
      call basa(' Sphere model')
      call putimage(131,368,selma7,3)
      ndil=12
      nxgit=n
      nart=1
      kk=1
      call degersor(tkm,tkh,tkural,tkbh,doscik,ndil)
      if(doscik.eq.11) then
	   call kose(131,335,161,447,7,7)
	   call basa('INTERPRETATION')
	   return
      endif
c*****************************************************
      gel(dsayi)=gelok
      tez(dsayi)='SPHERE'
      tekm(dsayi)=tkm
      tekh(dsayi)=tkh
      tekal(dsayi)=tkural
      dsayi=dsayi+1
c*****************************************************
      alfa=(tkural*3.14)/180.
      tkm=tkm*25.
      r1=sin(alfa)
      r2=cos(alfa)
      nart=1
      do i=verilk-gelok,verson-gelok
          yv(nart)=yv(nart)+(tkm*(i*r2-tkh*r1)/((i**2+tkh**2)**(1.5)))
	  nart=nart+1
      enddo
      do i=verilk,nart+verilk
	 xx(kk)=i
	 kk=kk+1
      enddo
      call vericiz()
c****************************************
      call setviewport(172,29,635,411)
c****************************************
      m=setcolor(15)
      call map(xmax,xmin,xx(1),30.,464.,xxi)
      call map(ymax,ymin,yv(1),380.,1.,yvi)
      xx1=xxi
      yv1=yvi
      call moveto(xx1,yv1,s)
      do i=2,nart
	   call map(xmax,xmin,xx(i),30.,464.,xxi)
	   call map(ymax,ymin,yv(i),380.,1.,yvi)
	   xx1=xxi
	   yv1=yvi
	   m=lineto(xx1,yv1)
       enddo
      call setviewport(0,0,639,479)
      call kose(131,335,161,447,7,7)
      call basa('INTERPRETATION')
      return
      end

C     *************************************************************
C     *              Cylinder anomaly                             *      
C     *************************************************************
      subroutine anomalisili(gelok)
      include 'fgraph.fd'
      character*8 tez(35)
      common /olsan / yv,xx
      common /anomali/ verilk,verson
      common /sert /xmax,xmin,ymax,ymin,n
      common /sayi/ nart
      common /say/ dsayi
      common /gf7/ selma7
      common /degerler/ gel,tez,tekm,tekh,tekal
      integer*1 selma7(520)
      dimension yv(1500),xx(1500)
      dimension gel(35),tekm(35),tekh(35),tekal(35)
      record/xycoord/s
      call basa('Cylinder model')
      call putimage(131,400,selma7,3)
      ndil=12
      nxgit=n
      nart=1
      kk=1
      call degersor(tkm,tkh,tkural,tkbh,doscik,ndil)
      if(doscik.eq.11) then
	   call kose(131,335,161,447,7,7)
	   call basa('INTERPRETATION')
	   return
      endif
c*****************************************************
      gel(dsayi)=gelok
      tez(dsayi)='CYLINDER'
      tekm(dsayi)=tkm
      tekh(dsayi)=tkh
      tekal(dsayi)=tkural
      dsayi=dsayi+1
c*****************************************************
      alfa=(tkural*3.14)/180.
      r1=sin(alfa)
      r2=cos(alfa)
      do i=verilk-gelok,verson-gelok
          yv(nart)=yv(nart)+(tkm*(i*r2-tkh*r1)/(i**2+tkh**2))
	  nart=nart+1
      enddo
      do i=verilk,nart+verilk
	 xx(kk)=i
	 kk=kk+1
      enddo
      call vericiz()
c****************************************
      call setviewport(172,29,635,411)
c****************************************
      m=setcolor(15)
      call map(xmax,xmin,xx(1),30.,464.,xxi)
      call map(ymax,ymin,yv(1),380.,1.,yvi)
      xx1=xxi
      yv1=yvi
      call moveto(xx1,yv1,s)
      do i=2,nart
	   call map(xmax,xmin,xx(i),30.,464.,xxi)
	   call map(ymax,ymin,yv(i),380.,1.,yvi)
	   xx1=xxi
	   yv1=yvi
	   m=lineto(xx1,yv1)
       enddo
      call setviewport(0,0,639,479)
      call kose(131,335,161,447,7,7)
      call basa('INTERPRETATION')
      return
      end

c     *************************************************************
c     *                 Sheet anomaly                             *      
c     *************************************************************
      subroutine anomalidilim(gelok)
      include 'fgraph.fd'
      character*8 tez(35)
      common /olsan / yv,xx
      common /anomali/ verilk,verson
      common /sert /xmax,xmin,ymax,ymin,n
      common /sayi/ nart
      common /say/ dsayi
      common /gf7/ selma7
      common /degerler/ gel,tez,tekm,tekh,tekal
      integer*1 selma7(520)
      dimension yv(1500),xx(1500)
      dimension gel(35),tekm(35),tekh(35),tekal(35)
      record/xycoord /s
      call basa ('Sheet model')
      call putimage(131,336,selma7,3)
      ndil=888
      nxgit=n
      nart=1
      kk=1
      call degersor(tkm,tkh,tkural,tkbh,doscik,ndil)
      if(doscik.eq.11) then
	   call kose(131,335,161,447,7,7)
	   call basa(' INTERPRETATION')
	   return
      endif
c*****************************************************
      gel(dsayi)=gelok
      tez(dsayi)='SHEET'
      tekm(dsayi)=tkm
      tekh(dsayi)=tkh
      tekal(dsayi)=tkural
      dsayi=dsayi+1
c*****************************************************
      alfa=(tkural*3.14)/180
      a=(tkbh-tkh)/tan(alfa)
      do i=verilk-gelok,verson-gelok
	  yv(nart)=yv(nart)+tkm*log((i**2+tkh**2)/((i-a)**2+tkbh**2))
	  nart=nart+1
      enddo
      do i=verilk,nart+verilk
	 xx(kk)=i
	 kk=kk+1
      enddo
      call vericiz()
c****************************************
      call setviewport(172,29,635,411)
c****************************************
      m=setcolor(15)
      call map(xmax,xmin,xx(1),30.,464.,xxi)
      call map(ymax,ymin,yv(1),380.,1.,yvi)
      xx1=xxi
      yv1=yvi
      call moveto(xx1,yv1,s)
      do i=2,nart
	   call map(xmax,xmin,xx(i),30.,464.,xxi)
	   call map(ymax,ymin,yv(i),380.,1.,yvi)
	   xx1=xxi
	   yv1=yvi
	   m=lineto(xx1,yv1)
       enddo
      call setviewport(0,0,639,479)
      call basa('INTERPRETATION')
      call kose(131,335,161,447,7,7)
      return
      end

C     *************************************************************
C     *            The role of the arrow                          *      
C     *************************************************************
      subroutine okcu()
      include'fgraph.fd'
      integer*1 selma1(240),xaxe(240)
      character*8 data,dymax,dymin
      common /gf1/ selma1
      common /kesik/ neksx
      common /doscu/ kayitno
      common /okgit/ pp,xaxe
      common /deger/ gx1,gx2
      common /sert/ xmax,xmin,ymax,ymin,n
      record /xycoord /s
      xaxe=selma1
      m=registerfonts('sptimes.fnt')
      m=setfont("t'tms rmn'h13w15b")
      call kose(110,463,350,474,7,7)
      m=setcolor(4)
      call moveto(115,459,s)    
      call outgtext('(1-9):')
      call moveto(125,460,s)
      call text(170,460,'SPEED OF ARROW')
      m=setfont("t'tms rmn'h11w15b")
      call moveto(350,461,S)   !new
      call outgtext('Use left/right key')  !new
	m=setcolor(1)
	m=rectangle(3,6,142,162,176)
	m=setfont("t'tms rmn'h11w9b")
	      m=setcolor(14)
	      call moveto(8,144,s)
              call outgtext('Vmin= ')
	      call moveto(8,160,s)
              call outgtext('Vmax= ')
	      call moveto(97,150,s)
	      call outgtext('x= ')
      call moveto(45,160,s)
      write(dymax,'(f8.2)') ymax
      call outgtext(dymax)
	call moveto(45,142,s)
	write(dymin,'(f8.2)') ymin
	call outgtext(dymin)
      pp=200
      artisok=10
      artisx=(gx2-gx1)/443
      pxidur=gx1
      pxsdur=gx2
      gelok=gx1
      call basa('INTERPRETATION')
    4 if(pp.lt.200) pp=200
      if(pp.gt.632) pp=632
      call putimage(pp,neksx+12,selma1,4)
      m=setcolor(1)
      m=rectangle(3,110,145,161,160)
      m=setcolor(14)
	 call moveto(116,150,s)
	 write(data,'(f6.2)') gelok
	 call outgtext(data)
C***********************************************************
C***********************************************************
    5 oku=readkey()
      if(oku.eq.27) then
		kayitno=2
		pp=610
		neksx=30
		call sil()
		m=setcolor(7)
		m=rectangle(3,6,142,162,176)
		call kose(110,459,350,474,7,7)
		call unregisterfonts()	
		return
      endif
      if(oku.eq.333) then
	 call putimage(pp,neksx+12,selma1,4)
	 gelok=gelok+artisx*artisok
	 pp=pp+artisok
	 if(gelok.gt.pxsdur) gelok=pxsdur
	 goto 4
      endif
C***********************************************************
      if(oku.eq.331) then
	  call putimage(pp,neksx+12,selma1,4)
	  gelok=gelok-artisx*artisok
	  pp=pp-artisok
	  if(gelok.lt.pxidur) gelok=pxidur
	  goto 4
      else
C***********************************************************
      if(oku.eq.112.or.oku.eq.80)  then
	   call anomalikure(gelok)
	   goto 5
      endif

      if(oku.eq.99.or.oku.eq.67)  then
	   call anomalisili(gelok)
	   goto 5
      endif

      if(oku.eq.115.or.oku.eq.83)  then
	   call anomalidilim(gelok)
	   goto 5
      endif
C************************************************************
	   if(oku.eq.48) artisok=10
	   if(oku.eq.49) artisok=1
	   if(oku.eq.50) artisok=2
	   if(oku.eq.51) artisok=3
           if(oku.eq.52) artisok=4           !*********************
           if(oku.eq.53) artisok=5           !*  Arrow speed      *
           if(oku.eq.54) artisok=6           !*********************
	   if(oku.eq.55) artisok=7
	   if(oku.eq.56) artisok=8
	   if(oku.eq.57) artisok=9
      goto 5
      endif
      goto 4
      end

C     *************************************************************
C     *                Input data                                 *      
C     *************************************************************
      subroutine degersor(tkurm,tkurh,tkural,tkurbh,doscik,ndil)
      include 'fgraph.fd'
    3 continue
      call text(14,196,'M(mV). :  ')   !20 idi
      call getr(90,196,tkurm,8,doscik) !76 idi
      if(doscik.eq.11) return
      call text(14,220,'h(m) . :  ')
      call getr(90,220,tkurh,8,doscik)
      if(doscik.eq.11) return
      if(ndil.eq.888) goto 48
      call text(14,244,'P.angle:  ')
      call getr(90,244,tkural,8,doscik)
      if(doscik.eq.11) return
c**********************************************************       
   46 call batik(11.,292.,157.,313.)
    5 oku=readkey()
      if(oku.eq.110.or.oku.eq.78) then
	   call kose(7,187,158,315,7,7)
	   goto 3
      endif
      if(oku.eq.121.or.oku.eq.89) then
	   call kose(7,187,158,315,7,7)
	   return
      else
      goto 5
      endif
   48 call text(14,244,'H(m) . :  ')
      call getr(90,244,tkurbh,8,doscik)
      if(doscik.eq.11) return
      call text(14,268,'P.angle:  ')
        call getr(90,268,tkural,8,doscik)
      if(doscik.eq.11) return
      goto 46
      end

C     *************************************************************
C     *               Screen configuration                        *      
C     *************************************************************
      subroutine ekran
	call tleky(0,0,639,25,7)          !upp menu
	call tlekd(55,0,25)               !file
        call tlekd(110,0,25)              !notes
        call tlekd(165,0,25)              !print
        call tlekd(169,0,25)              !extra
        call tleky(0,455,639,479,7)       !below menu
        call tlekd(463,455,479)           !name
        call tleky(169,26,639,454,0)      !graphic box
        call tleky(0,26,168,135,7)        !selection menu
        call tleky(0,136,168,198,7)       !X,Y values
        call tleky(0,179,168,420,7)       !input data    !320--420
        call tleky(0,321,168,454,7)       !Sphere,cylinder,sheet
        call high(4.,164.,325.,450.)      !sphere
        call high(4.,164.,183.,320.)      !value
        call high(4.,164.,140.,178.)      !x and y
        call tlekd(0,136,454)             !left
        call tlekd(165,136,454)           !right
        call fksi1()
      return
      end


      subroutine tleky(nx1,ny1,nx2,ny2,nic)
      include 'fgraph.fd'
      record /xycoord/ xy
       m=setcolor(15)
       m=rectangle(2,nx1,ny1,nx2,ny2)
       m=setcolor(2)
       m=rectangle(2,nx1+3,ny1+3,nx2-3,ny2-3)
       call moveto(nx1,ny2,xy)
	   m=lineto(nx2,ny2)
	   m=lineto(nx2,ny1)
	   m=setcolor(15)
      call moveto(nx1+3,ny2-3,xy)
	   m=lineto(nx2-3,ny2-3)
	   m=lineto(nx2-3,ny1+3)
	   m=setcolor(7)
	   m=rectangle(2,nx1+1,ny1+1,nx2-1,ny2-1)
	   m=rectangle(2,nx1+2,ny1+2,nx2-2,ny2-2)
	   m=setcolor(nic)
	   m=rectangle(3,nx1+4,ny1+4,nx2-4,ny2-4)
      return
      end


      subroutine tlekd(nx1,ny1,ny2)
      include 'fgraph.fd'
      record /xycoord/ xy
	m=setcolor(15)
	call moveto(nx1,ny1+3,xy)
		m=lineto(nx1,ny2-3)
		m=setcolor(7)
		m=rectangle(2,nx1+1,ny1+3,nx1+2,ny2-3)
		m=setcolor(0)
	call moveto(nx1+3,ny1+3,xy)
	m=lineto(nx1+3,ny2-3)
      return
      end

      subroutine sil()
      include'fgraph.fd'
      m=setcolor(3)
      m=rectangle(3,4,30,164,131)
      return
      end

      subroutine high(x1,x2,y1,y2)
      include 'fgraph.fd'
      record /xycoord/ s
      m=setcolor(15)
      call moveto(x2,y1,s)
	      m=lineto(x1,y1)
	      m=lineto(x1,y2)
	      m=lineto(x1+1,y2)
	      m=lineto(x1+1,y1+1)
	      m=lineto(x2-1,y1+1)
	      m=setcolor(8)
	      m=lineto(x2-1,y2-1)
	      m=lineto(x1+1,y2-1)
	      m=lineto(x1,y2)
	      m=lineto(x2,y2)
	      m=lineto(x2,y1)
      return
      end
C     *************************************************************
C     *               Cover algorithm                             *      
C     *************************************************************
      subroutine giris(ndon)
      include 'fgraph.fd'
      real*4 rr
      integer*2 iirand
      integer*2 irand
      integer*1 selma5(13500)
      common /gf5/ selma5
      record /xycoord /s
c     call putimage(10,10,selma5,3)
	  do i=1,1000
	      call random(rr)
	      irand= rr*256
	      ni=mod(irand,16)
	      if(ni.eq.0) ni=4
	      m=setcolor(ni)
	      call random(rr)
	      irand= rr*640
	      call random(rr)
	      iirand=rr*480
	      m=setpixel(irand,iirand)
	  enddo
      m=setcolor(14)
      m=registerfonts('sprom.fnt')
      m=setfont("t'roman'h80w50b")
      call moveto(100,30,s)
      call outgtext('SPINTERP')
      m=setfont("t'roman'h16w14b")
      call moveto(90,125,s)
      call outgtext('(Visual interpretation of SP anomaly)')
      call text(210,400,'!!Press a key to continue..')
      m=registerfonts('sptimes.fnt')
      m=setfont("t'tms rmn'h13w15b")
      call moveto(270,280,S)
      call outgtext('I.Caglar')
      call moveto(230,300,S)
      call outgtext('email: caglari@itu.edu.tr')
      call unregisterfonts()
      oku=readkey()
      if(oku.eq.27) goto 20
      goto 11
   20 ndon=5
      call kapan()
   11 continue
      return
      end
      subroutine kapan()
      include 'fgraph.fd'
      m=setcolor(0)
	do i=1,250,10
	   m=rectangle(3,0,0,i,479)
	   m=rectangle(3,639-i,0,639,479)
	   m=rectangle(3,0,0,639,i)
	   m=rectangle(3,0,479,639,479-i)
	enddo
      return
      end

      subroutine kose(nx1,ny1,nx2,ny2,nrenk,nrek)
      include 'fgraph.fd'
      m=setcolor(nrenk)
      m=rectangle(2,nx1,ny1,nx2,ny2)
      m=rectangle(2,nx1+1,ny1+1,nx2-1,ny2-1)
      m=rectangle(2,nx1+2,ny1+2,nx2-2,ny2-2)
      m=rectangle(2,nx1+3,ny1+3,nx2-3,ny2-3)
      m=rectangle(2,nx1+4,ny1+4,nx2-4,ny2-4)
      m=rectangle(2,nx1+5,ny1+5,nx2-5,ny2-5)
      m=rectangle(2,nx1+6,ny1+6,nx2-6,ny2-6)
      m=setcolor(nrek)
      m=rectangle(3,nx1+6,ny1+6,nx2-6,ny2-6)
      return
      end

C     *************************************************************
C     *                   common exit                             *      
C     *************************************************************
      subroutine cikis(gm,ss,nxh)
      include 'fgraph.fd'
      integer*1 ismail(5550)
      character*(*) ss
      call getimage(220,230,590,260,ismail)
      call tleky(220,230,590,260,7)
      call text(nxh,239,ss)  !247
    4 oku=readkey()
      if(oku.eq.121.or.oku.eq.89) then
	  call putimage(220,230,ismail,3)
	  call sil()
	  gm=27
	  return
      endif
      if(oku.eq.110.or.oku.eq.78) then
	  call putimage(220,230,ismail,3)
	  return
      endif
      goto 4
      end

      subroutine dossor()
      call sil()                             !********************
      call altciz(40,60,124,4)               !*   ask file       *
      call altciz(20,88,144,4)               !********************
      call text(46,45,"FILE NAME: ")
      return
      end

      subroutine map(xmax,xmin,x,emin,emax,pxy)
      eg=(emax-emin)/(xmax-xmin)
      pxy=(x-xmin)*eg+emin
      return
      end

      subroutine ciziekran()
      include 'fgraph.fd'
      integer*1 xaxe(240)
      common /okgit /pp,xaxe
      common /kesik/ neksx
      common /sert /xmax,xmin,ymax,ymin,n
      character*8 elif1,elif2,elif3,elif4
      character*9 m1
      record/xycoord/s
      call kose(173,29,635,434,0,0)
      call putimage(pp,neksx+12,xaxe,4)
      m=setcolor(0)
      m=rectangle(3,600,32,630,90)
      m=registerfonts('sptimes.fnt')
      m=setfont("t'tms rmn'h12w7b")
      m1='M LL VOLT'
      m=setcolor(14)
	  write(elif1,'(f6.0)') ymax
	  write(elif2,'(f6.0)') ymin
	  write(elif3,'(f6.0)') xmin
	  write(elif4,'(f6.0)') xmax
		call moveto(173,30,s)
		call outgtext(elif1)
		call moveto(173,403,s)
		call outgtext(elif2)
		call moveto(190,422,s)
		call outgtext(elif3)
		call moveto(610,422,s)
		call outgtext(elif4)
       do i=1,9 !8idi
	  call moveto(180,70+i*20,s)
	  call outgtext(M1(i:i))
      enddo
	call moveto(183,70+2*20,s)
	call outgtext('I')
	call moveto(183,70+5*20,s)
	call outgtext('I')
	call moveto(395,422,s)
      m=setfont("t'tms rmn'h18w9b")
      call outgtext('X(meters)')
      m=setcolor(11)
      call setlinestyle(15)
      m=setfont("t'tms rmn'h12w9b")
      do i=288,549,87
	 call moveto(i,29,s)
	 m=lineto(i,411)
      enddo
      do i=105,336,77
	 call moveto(190,i,s)
	 m=lineto(635,i)
      enddo
      call setlinestyle(65535)
      m=setcolor(3)
      m=rectangle(2,201,29,635,411)
      return
      end

      subroutine kordon(xmax,xmin,x,n)
      dimension x(n)
      xmax=x(1)
      xmin=x(1)
      do i=2,n
	  if(xmax.lt.x(i)) xmax=x(i)
	  if(xmin.gt.x(i)) xmin=x(i)
      enddo
      return
      end

      subroutine vericiz()
      include'fgraph.fd'
      dimension x(1500),y(1500)
      common /kayiticin/ x,y
      common /sert /xmax,xmin,ymax,ymin,n
      common /kesik/ neksx
      common /deger/ gx1,gx2
      common /anomali/ verilk,verson
      record/ xycoord/ s
      gx1=x(1)
      gx2=x(n)
      verilk=x(1)
      verson=x(n)
      call kordon(xmax,xmin,x,n)
      call kordon(ymax,ymin,y,n)
      call ciziekran()
c**** ********************************************************** 
      call setviewport(172,29,635,411)
c**** ********************************************************** 
      call map(xmax,xmin,x(1),30.,462.,xi)
      call map(ymax,ymin,y(1),380.,1.,yi)
      x1=xi
      y1=yi
      call moveto(x1,y1,s)
      m=setcolor(14)
      do i=2,n
	   call map(xmax,xmin,x(i),30.,462.,xi)
	   call map(ymax,ymin,y(i),380.,1.,yi)
	   x1=xi
	   y1=yi
	   m=lineto(x1,y1)
      enddo
	   call map(ymax,ymin,0.,380.,1.,yi)
	   neksx=yi
	   m=setcolor(12)
	   call moveto(30,neksx,s)
	   m=lineto(462,neksx)
   37 call setviewport(0,0,639,479)
      return
      end

      subroutine KisaBilg()
      call altciz(15,83,151,4)
      call text(30,68,'short notes')
      return
      end

      subroutine altciz(nx1,ny,nx2,ncolor)
      include 'fgraph.fd'                   !*************
      record/xycoord /s                     !*   outline *
      m=setcolor(ncolor)                    !*************
      call moveto(nx1,ny,s)
      m=lineto(nx2,ny)
      return
      end

      subroutine getr(nx,ny,sayi,max,doscik)
      include 'fgraph.fd'
      character*1 stri(20)
      character*80 str,str1
      equivalence (str1,stri)
      record /xycoord/ xc
      doscik=15
      do i=1,20
      stri(i)=' '
      enddo
      nf=0
      na=0
      nokta=0
    1 call moveto(nx,ny,xc)
      k=readkey()
      if(k.eq.27) then
	m=setcolor(7)
	m=rectangle(3,6,185,160,318)
	  doscik=11
	  return
      endif
	   if((k.gt.47.and.k.lt.58).or.(k.eq.46.and.nokta.eq.0).and.na.
     1 lt.4) then
	    if(nf.gt.max-1) goto 1
	     nf=nf+1
	     if(nokta.eq.1) na=na+1
	     stri(nf)=char(k)
	     if(char(k).eq.'.') nokta=1
	endif
	if(k.eq.8) then
	     if(nf.gt.0) then
	       if(na.gt.0) na=na-1
	       if(stri(nf).eq.'.') nokta=0
	       stri(nf)=char(32)
	       nf=nf-1
	     endif
	endif
      if(k.eq.13) then
	   m=setcolor(7)
	   m=rectangle(3,nx,ny,nx+max*8,ny+15)
	    if(nokta.eq.0) stri(nf+1)='.'
	   read(str1,'(f19.2)') sayi
	   str=str1
	   call text(nx,ny,str1)
	   return
      endif
      m=setcolor(7)
      m=rectangle(3,nx,ny,nx+max*8,ny+15)
      call text(nx,ny,str1)
      go to 1
      end

      subroutine fksi1()
      include'fgraph.fd'
      record /xycoord /s
      m=registerfonts('sptimes.fnt')
      m=setfont("t'tms rmn'h13w15b")     
      call text(12,344,'   SHEET')
      call text(12,376,'   SPHERE')
      call text(12,408,'   CYLINDER')
      m=setcolor(4)
      call moveto(6,460,s)
      call outgtext('ESC:')
      m=setfont("t'tms rmn'h11w15b")
      call moveto(10,425,S)
      call outgtext(' select a model')
      call moveto(10,435,S)
      call outgtext(' pressing S, P or C')   
      m=setfont("t'tms rmn'h13w15b")
	m=setcolor(1)
        call moveto(10,343,S)
        call outgtext('S')
        call moveto(10,375,S)
        call outgtext('P')
        call moveto(10,407,S)
        call outgtext('C')
	call unregisterfonts()
	call text(470,460,'I.Caglar, 1999')
	call text(245,6,'SPINTERP-Visual interpretation of SP anomalies')
	call text(50,461,'EXIT')
      return
      end




C     *************************************************************
C     *                SP MENUS                                   *      
C     *************************************************************
      subroutine spler()
      character*17 sp(16)
      common /sp/ sp
      sp(1)='File'
      sp(2)='Print'
      sp(3)='Notes'
      sp(4)=' '
      sp(5)=' File input'
      sp(6)=' Interpretation'
      sp(7)=' Model saving'
      sp(8)=' Model input'
      sp(9)=' Graphic output'
      sp(10)=' Result output'
      sp(11)=' Result notes'
      sp(12)='!check printer!'
      sp(13)=' About SPINTERP'   
      sp(14)=' Cylinder model'  
      sp(15)=' Sheet model'     
      sp(16)=' Sphere model'     
      return
      end
C**************************************************************
      subroutine text(nx,ny,c)
      include 'fgraph.fd'
      character*(*) c
      character*80 line
      character*1 input(80)
      integer*1 yazi(68,96)
      dimension k(96),l(96)
      common /harf/ yazi,k,l
      record /xycoord/ poz
      equivalence (line,input)
      call moveto(nx,ny,poz)
      nxx=nx
      line=c
      m=len_trim(line)
      do i=1,m
	 do j=1,96
	    if(ichar(input(i)).eq.k(j)) then
	    call putimage(nxx,ny,yazi(1,j),4)
	    nxx=nxx+8
	    goto 6
	 endif
      enddo
    6 continue
      enddo
      call moveto(nx,ny,poz)
      return
      end


      subroutine menu1gir(n)
      if(n.eq.0)then
	 call menu1(1,7)
	 call menu1(2,7)
	 call menu1(3,7)
      endif
      if(n.eq.1)then
	 call menu2(5,9)
	 call menu2(6,7)
	 call menu2(7,7)
	 call menu2(8,7)
      endif
      if(n.eq.2)then
	 call menu2(9,9)
	 call menu2(10,7)
	 call menu2(11,7)
	 call menu2(12,7)
      endif
      if(n.eq.3)then
	 call menu2(13,9)
	 call menu2(14,7)
	 call menu2(15,7)
	 call menu2(16,7)
      endif
      return
      end

      subroutine menu1(n,ncol)     !blue box
      include 'fgraph.fd'
      character*17 sp(16)
      common /sp/ sp
      m=setcolor(ncol)
      m=rectangle(3,n*55-51,4,n*55-1,21)
      call text(n*55-45,4,sp(n))
      return
      end

      subroutine menu2(n,ncol)
      include 'fgraph.fd'
      character*17 sp(16)
      common /sp/ sp
      m=setcolor(ncol)
      ni=mod(n,4)
      if(ni.eq.0) ni=4
      m=rectangle(3,15,ni*20+25,154,ni*20+45)
      call text(15,ni*20+28,sp(n))
      return
      end

      subroutine gets(nx,ny,str,max,doscik)
      include'fgraph.fd'
      character*1 stri(80)
      character*80 str,str1
      equivalence (str1,stri)
      record /xycoord/ xc
      do i=1,80
      stri(i)=' '
      enddo
      nf=0
    1 call moveto(nx,ny,xc)
      k=readkey()
      if(k.eq.27) then
	   doscik=11
	   return
      endif
      if(k.gt.31.and.k.lt.127) then
	  if(nf.gt.max-1) goto 1 !
	  nf=nf+1
	  stri(nf)=char(k)
      endif
      if(k.eq.8) then
	  if(nf.gt.0) then
	     stri(nf)=char(32)
	     nf=nf-1
      endif
      endif
      if(k.eq.13) then
	    m=setcolor(7)
	    m=rectangle(3,nx,ny,nx+max*8,ny+15)
	    str=str1
	    return
      endif
      m=setcolor(7)
      m=rectangle(3,nx,ny,nx+max*8,ny+15)
      call text(nx,ny,str1)
      go to 1
      end
	
C     *************************************************************
C     *                  GRAPHIC printer                          *      
C     *************************************************************
      subroutine printer(marj,nx1,ny1,nx2,ny2,nbos)
      include 'fgraph.fd'
      integer*1 buf(1000)
      integer*2 d2
      integer*1 toplam
      integer*1 on(5)
      integer*1 son(6)
      open(10,file='prn')
      do I = 1 , nbos
       write(10,*)' '
      enddo
      close(10)
      open(10,file='prn',form='binary')
      son(5)=13
      son(6)=10
      do j=ny1,ny2,8
	nt=1
	do i=nx1,nx2,1
	  toplam=0
	  do k=0,7
	    d2=getpixel(i,j+k)
	    if(d2.ne.0) toplam=toplam+2**(7-k)
	  enddo
	  buf(nt)=toplam
	  nt=nt+1
	enddo
      on(1)= 27
      on(2)= 76
      on(3)= mod(2*(nx2-nx1+1)+marj,256)
      on(4)= (2*(nx2-nx1+1)+marj)/256
	do p=1,4
	   write(10) on(p)
	enddo
      on(5)=0
	do p=1,marj
	   write(10) on(5)
	enddo
	do t=1,nx2-nx1+1
	  write(10) buf(t)
	  write(10) buf(t)
	enddo
      son(1)= 13
      son(2)= 27
      son(3)= 74
      son(4)= 24
	do p=1,4
	  write(10) son(p)
       enddo
      enddo
      close(10)
      return
      end
C     *************************************************************
C     *                PRINTER notes                              *      
C     *************************************************************
      subroutine printuyari(tprint,doscik)
      include 'fgraph.fd'
      character*40 tprint
      integer*1 selma6(520)
      common /gf6/ selma6
      call tleky(210,100,600,200,7)
      call putimage(218,110,selma6,3)
      m=setcolor(9)
      m=rectangle(3,545,422,631,443)
      call text(550,427,'ESC:Cancel')
      call text(254,112,'If the printer is ready, please write  ')
      call text(254,127,'title and then press ENTER ....')
      call text(215,180,'Title :')
      call gets(270,180,tprint,40,doscik)
      return
      end


      subroutine hata(p)
      include 'fgraph.fd'
      character*(*) p
      call kose(4,30,164,131,9,7)
      call altciz(15,83,151,4)
      call text(30,68,p)
      oku=readkey()
      call sil()
      return
      end


      subroutine batik(x1,y1,x2,y2)
      include'fgraph.fd'
      record /xycoord /s
      m=registerfonts('sptimes.fnt')
      m=setfont("t'tms rmn'h11w9b")
      m=setcolor(4)
      m=rectangle(3,x1,y1,x2,y2)
      m=setcolor(14)
      call moveto(x1+3,y1+2,s)
      call outgtext('!Values OK?(Yes-y No-n)')
      call moveto(x1+16,y1-3,s)
c     call outgtext('  -  ')
      call moveto(x1+76,y1-3,s)
c     call outgtext('-')
      call moveto(x1-1,y1-1,s)
      m=setcolor(0)
      m=lineto(x2+1,y1-1)
      call moveto(x1-1,y1-1,s)
      m=lineto(x1-1,y2+1)
      m=setcolor(15)
      call moveto(x1-1,y2+1,s)
      m=lineto(x2+1,y2+1)
      call moveto(x2+1,y1-1,s)
      m=lineto(x2+1,y2+1)
      return
      end

      subroutine basa(p)
      include 'fgraph.fd'
      character*(*) p                        !******************
      call kose(4,30,164,131,7,7)            !*   Descriptions *   
      call altciz(15,83,151,4)               !******************
      call text(23,68,p)
      return
      end

      subroutine kontrol()
      dimension k(96),l(96)
      integer*1 yaz(68,96)
      integer*1 selma1(240),selma5(13500),selma6(520),selma7(520)
      integer*1 selma2(3500),selma3(3500),selma4(3770)
      common /harf/ yaz,k,l
      common /gf1/ selma1
      common /gf2/ selma2
      common /gf3/ selma3
      common /gf4/ selma4
      common /gf5/ selma5
      common /gf6/ selma6
      common /gf7/ selma7
      open(1,file='ekmod.dkd',status='old',form='binary',err=7)
      do i=1,142
	read(1) selma1(i)          ! selma1= arrow
      enddo
      do i=1,3465
	read(1) selma2(i)          ! selma2= cylinder
      enddo
      do i=1,3465
	read(1) selma3(i)          ! selma3= sphere
      enddo
      do i=1,3762
	read(1) selma4(i)          ! selma4= sheet
      enddo
      do i=1,13470
	read(1) selma5(i)          ! selma5= spari
      enddo
      do i=1,518
	read(1) selma6(i)          ! selma6= note
      enddo
      do i=1,96
       read(1) k(i),l(i)
	   do j=1,l(i)             !ekmod file
	     read(1) yaz(j,i)
	   enddo
      enddo
      do i=1,518
	read(1) selma7(i)          ! selma7= el
      enddo
      close(1)
      goto 8
    7 stop 'Ekmod.dkd is not found      '
    8 return
      end

      subroutine kontrol1()
      include 'fgraph.fd'
      nhata=0
      if( registerfonts('spbole.fnt' ). LT. 0 ) then
      print*,' SPBOLE.FNT  is not found      '
      nhata=1
      endif
      if( registerfonts('sprom.fnt' ). LT. 0 ) then
      print*,' SPROM.FNT  is not found      '
      nhata=1
      endif
      if( registerfonts('sptimes.fnt' ). LT. 0 ) then
      print*,' SPTIMES.FNT  is not found      '
      nhata=1
      endif
      if(nhata.eq.1) stop ' '
      goto 2
    2 return
      end
